package lab6;

import c4e.phidget.Event;
import c4e.phidget.HardwareInterface;

public class HeartMonitor extends HardwareInterface
{
	private double maxResponse;
	private long lastMax;
	private long lastMin;
	private ViewMain view;

	public HeartMonitor(boolean debug, ViewMain view)
	{
		super(debug);
		this.view = view;
		this.maxResponse = 0.0f;
		this.lastMax = 0;
		this.lastMin = 0;
	}

	@Override
	public void analogInputChanged(Event ae)
	{
		double value = ae.getValue();
		if (value > maxResponse) maxResponse = value;
		System.out.println(value +", "+ maxResponse);

		this.view.getStripChart().setValue(value);
		if (value > 0.6 * maxResponse)
		{
			this.view.getBeatStatus().setState(true);
			if (this.lastMax == 0)
			{
				this.lastMax = ae.getWhen();
				this.lastMin = 0;
			} else if (this.lastMin != 0)
			{
				long dt = ae.getWhen() - lastMax;
				int bpm = (int) (60 * 1000 / (double) dt + 0.5);
				this.view.getRateLabel().setText("" + bpm);
				this.lastMax = ae.getWhen();
				this.lastMin = 0;
			}
		} else
		{
			this.view.getBeatStatus().setState(false);
			if (this.lastMin == 0) this.lastMin = ae.getWhen();
		}
	}

}
