package lab6;

import javax.swing.*;

import java.awt.*;
import java.awt.event.*;

@SuppressWarnings("serial")
public class ViewMain extends JFrame implements ActionListener
{
	private ViewBeatStatus beatStatus;
	private ViewStripChart stripChart;
	private JLabel rateLabel;
	private JButton quit;

	public ViewMain()
	{
		this.setLayout(new FlowLayout());
		this.stripChart = new ViewStripChart();
		this.add(stripChart);
		this.beatStatus = new ViewBeatStatus();
		this.add(beatStatus);

		JPanel panel = new JPanel();
		panel.setLayout(new GridLayout(0, 1));
		panel.add(new JLabel("Heart Monitor V1.0"));

		JPanel p1 = new JPanel();
		p1.setLayout(new FlowLayout());
		p1.add(new JLabel("Rate "));
		this.rateLabel = new JLabel("000");
		p1.add(rateLabel);
		panel.add(p1);

		this.quit = new JButton("Quit");
		this.quit.addActionListener(this);
		panel.add(quit);
		this.add(panel);
		this.pack();

		this.setTitle("Heart Beat Monitor");
		this.setResizable(false);
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		// put this in the centre of the screen
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		this.setLocation((screenSize.width - this.getSize().width) / 2,
				(screenSize.height - this.getSize().height) / 2);

	}

	public void actionPerformed(ActionEvent e)
	{
		if (e.getSource() == quit)
			System.exit(0);
	}

	public ViewBeatStatus getBeatStatus()
	{
		return this.beatStatus;
	}

	public ViewStripChart getStripChart()
	{
		return this.stripChart;
	}

	public JLabel getRateLabel()
	{
		return this.rateLabel;
	}
	
	
	

}
