package lab6;

import javax.swing.*;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

@SuppressWarnings("serial")
public class ViewStripChart extends JPanel implements ActionListener
{
	private static final int WIDTH = 800;
	private static final int HEIGHT = 600;
	private static final int MAX_VALUE = 1000;
	private static final int UPDATE_FREQUENCY = 10; // in ms

	private int xValue;
	private int sensorValue;
	private int[] yValues = new int[WIDTH];

	private Dimension size;

	public ViewStripChart()
	{
		super();
		size = new Dimension(WIDTH, HEIGHT);
		this.setSize(size);
		this.xValue = -1;
		Timer timer = new Timer(UPDATE_FREQUENCY, this);
		timer.start();
	}

	public void actionPerformed(ActionEvent e)
	{
		this.repaint();
	}

	public void setValue(double value)
	{
		this.sensorValue = HEIGHT - (int) (HEIGHT * value / MAX_VALUE);
	}

	public void paintComponent(Graphics g)
	{
		this.xValue = (this.xValue + 1) % WIDTH;
		this.yValues[this.xValue] = sensorValue;

		g.setColor(Color.BLACK);
		g.fillRect(0, 0, WIDTH, HEIGHT);
		g.setColor(Color.WHITE);
		g.drawLine(0,  0,  WIDTH-1,  HEIGHT-1);
		g.drawLine(0,  HEIGHT-1,  WIDTH-1,  0);
		
	}

	public Dimension getPreferredSize()
	{
		return this.size;
	}
}
